/*-
 * ~~~~~~licensing~~~~~~
 * artifact-management
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.artifact.repository.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RepositoryConfigurableHelper extends RepositoryDescriptor {

	private static final List<RepositoryConfigurableHelper> helpers = new ArrayList<>(); 
	
	private static final Logger log = LoggerFactory.getLogger(RepositoryConfigurableHelper.class);
	
	RepositoryConfigurableHelperCollector collector;

	public void init() {
		if (collector != null)
			collector.addConfigurableHelper(this);
		log.info("Helper with name [{}] created", name);
		RepositoryConfigurableHelper.helpers.add(this);
		log.info("Total helpers: {}:\n{}", 
				"" + RepositoryConfigurableHelper.helpers.size(),
				RepositoryConfigurableHelper.helpers.stream()
						.map((h)->h.getName()).collect(Collectors.joining("\n\t", "\t", "")));
	}
	
	public void setCollector(RepositoryConfigurableHelperCollector collector) {
		this.collector = collector;
	}
	
}
